#Script for downscaling (Byman Hamadudu)
#Author: Byman H. Hamududu 14. Aug. 2010 Trondheim, Norway

#Modifications: 
#Byman H. Hamududu & Erle Kristvik, Spring 2015 Trondheim, Norway


library(clim.pact)
setwd("/Users/erlekristvik/Documents/test") 

ele=601;cmons=1:12;silent=FALSE;new.plot=TRUE;
do.20c=TRUE;qc=FALSE;station="Bergen_Florida";
scen="rcp45";post=FALSE;passwd=NULL;
predictand = "florida";v.names=c('tas','pr');
test=FALSE;replace=NULL;ipcc.ver="AR5";
off=FALSE;LINPACK=TRUE;downloads.since=NULL;
op.path="output";C20="historical";
t.rng=c("1-Jan-1960","-Dec-1999"); 
t1.rng=c("1-Jan-2000","31-Dec-2099");
dir="/Users/erlekristvik/Documents/test/IPCC_AR5/GCMs/";
surfts="atm/mo/ ";op.path="output";v.names=c('tas','pr');
force=FALSE

#-----------------

#ds.one(ele=601,cmons=1:12,silent=FALSE,new.plot=TRUE,
		#do.20c=TRUE, do.rcm=0,qc=FALSE,scen="rcp85",post=FALSE,
		#passwd=NULL,predictand = "ncep",station="Bergen_Florida",
		#test=FALSE,replace=NULL,ipcc.ver="AR5.",off=FALSE,
		#LINPACK=FALSE,downloads.since=NULL,C20="historical",
		#path=NULL,op.path="output",stop.on.poor.perf=FALSE,
		#min.yrs=30,min.n.valid=300, v.names=c('tas','pr'),
		#force=FALSE,exclude=NULL,force.inside=TRUE,lon=NULL,
		#lat=NULL,economic=TRUE,plot=FALSE,wOBS=0.25,lsave=TRUE,
		#t.rng=c("1-Jan-1900","31-Dec-1999"), 
		#t1.rng=c("1-Jan-2000","31-Dec-2099"))
#-----------------		   
v.nam<-switch(as.character(ele),`101`=v.names[1],`601`=v.names[2]) 

gcms <- list.files(path=dir,pattern=v.nam)
print(gcms)
gcms <- gcms[grep(".nc",gcms)]
gcms <- gcms[grep(v.nam,gcms)]

if(length(grep(".nc.part",gcms))>0)gcms<-gcms[-grep(".nc.part",gcms)]

if (!is.null(C20)) {
  gcms1<-reverse(gcms[grep(C20,lower.case(gcms))]) 
} else {
  gcms1 <- NULL
}
gcms2 <- reverse(gcms[grep(scen,gcms)])

if (!do.20c)
  C20 <- NULL
  
if ( (op.path!="./") & !exists(op.path) ) {
  print(paste("Create new directory (1):",op.path))
  dir.create(op.path )
}

print("Get gridded observations")
if (ele==101) {
  
  ncep<- retrieve.nc("gridded_obs.nc", v.nam="tas",
  					x.rng=c(-30,40),y.rng=c(40,75))
  
} else if (ele==601) {
  
ncep<- retrieve.nc("prate.sfc.mon.mean.nc", v.nam="pr",
                    x.rng=c(-30,40),y.rng =c(40,75))
                    
  ncep$dat <- ncep$dat*3600*24*30
  
}

if (!is.null(C20)) print(gcms1)
if (!silent) { print("GCMS:"); print(gcms2)}
if (class(station)[1]=="character") {
  
  if (ele==101) {
    load('point.obs.RData')
    print(bf_t$location)
    print(bf_t)
    
    obs<-bf_t
    
  } else if (ele==601){
    
    load('Bergen_Florida_pr.Rdata')
    print(bf_p$location)
    print(bf_p)
    
    obs<-bf_p
    
  }
  
} 

if (sum(is.na(obs$val))>0) 
  obs$val[length(obs$yy),] <- NA
x.rng <- c(max(c(obs$lon-20,-180)), min(c(obs$lon+20,180)))
y.rng <- c(max(c(obs$lat-20,-90)), min(c(obs$lat+15,90)))

print(x.rng); print(y.rng)

fname <- paste("ds_one_",ipcc.ver,"_",
        strip(obs$location),"_",ele,sep="")
print(fname)

fname.png <- paste("ds_one_",ipcc.ver,"_",
            strip(obs$location),"_",ele,
				  ".png",sep="") 
filename=paste(getwd(),"/",fname.png,sep="")

plot(c(1900,2100),c(min(rowMeans(obs$val[,cmons]),na.rm=TRUE)-15,
     max(rowMeans(obs$val[,cmons]),na.rm=TRUE)+20),type="n",
     main=paste(substr(lower.case(attr(obs,"location")),1,5),
     attr(obs,"country"),sep=", "),ylab=obs$obs.name,xlab="Years")
grid()


obs.ts <- plotStation(obs,what="t",add=TRUE,col="grey20",
					 type="p",pch=19,l.anom=FALSE,mon=cmons,
             		 trend=TRUE,std.lev=FALSE)

print(obs$location)
i.gcm <- 0
if (!is.null(C20)) {
  for (gcm in gcms1) {
    i.gcm <- i.gcm + 1
    print(gcm)
    dot <- instring(".",gcm)
    if (length(dot)>=3) {
      
      gcm.nm <- substr(gcm,dot[1]-40,dot[1]-37)
      
    } else {
      dash <- instring("_",gcm)
      gcm.nm <- substr(gcm,dash[2]+1,dash[3]-1)
    }
    
    slsh <- instring("/",obs$location)
    if (slsh[1] > 0) {
      obs$location <- substr(obs$location,1,slsh[1]-1)
    }
    
    subdir <- paste(strip(obs$location),ele,sep="_")
    fname <- paste(op.path,"/",subdir,"/ds_one_",ipcc.ver,"_",
                   strip(obs$location),"_",ele,
                   "_",gcm.nm,"_",C20,".",sep="")
                   
    if (!file.exists(paste(op.path,"/",subdir,sep=""))) {
      if (!silent) print(paste("Creating
      (2)",op.path,"/",subdir,sep=""))
      dir.create(paste(op.path,"/",subdir,sep="") )
    } else if (!silent) print(paste(op.path,"/",subdir,
    "exists...",sep=""))
    
    if (!silent) print(fname)
    if (!file.exists(paste(fname,"txt",sep=".")) &
          !file.exists(paste(fname,"Rdata",sep=".")) | (force)) {
      
      GCM<-retrieve.nc(paste(dir,gcm,sep=""),
      				  x.rng=x.rng,y.rng=y.rng,v.nam=v.nam,
      				  silent=FALSE)
      
      class(GCM) <- c("field","monthly.field.object")
      
      GCM$attributes$time.unit<- "month"; GCM$dd[] <- 15
      attr(GCM$tim, "unit")<- "month";
      GCM$dat <- switch(as.character(ele),'101'=GCM$dat-273.15,
      '601'=GCM$dat*3600*24*30)
      
      ds.station <- objDS(ncep,GCM,obs,mon=cmons,plot=TRUE,
      				direc="dsgraphicsoutput/",qualitycontrol=qc,
      				silent=silent,LINPACK=LINPACK)
      				
    x <- ds.station$station
    print(paste("Saving in",fname))
  save(file=paste(getwd(),"/",fname,"Rdata",sep=""),x,ds.station)
      
 ds.scen <- data.frame(Year=x$yy,
                  Jan=round(x$val[,1],2),Feb=round(x$val[,2],2),
                  Mar=round(x$val[,3],2),Apr=round(x$val[,4],2),
                  May=round(x$val[,5],2),Jun=round(x$val[,6],2),
                  Jul=round(x$val[,7],2),Aug=round(x$val[,8],2),
                  Sep=round(x$val[,9],2),Oct=round(x$val[,10],2),
                  Nov=round(x$val[,11],2),Dec=round(x$val[,12],2)
                    )
      
      write.table(ds.scen,file=paste(fname,"txt",sep=""),
                  row.names = FALSE,quote = FALSE, sep="\t ") 
                  
    } else {
      load(paste(fname,"Rdata",sep="."))
      print(paste(fname,"exists, reading from file."))
    }
    
    plotStation(x,what="t",add=TRUE,col="grey40",type="l",lwd=2,
                lty=1,l.anom=FALSE,mon=cmons,trend=TRUE,
                std.lev=FALSE)
                
    plotStation(obs,what="t",add=TRUE,col="grey20",type="p",pch=19,
                l.anom=FALSE,mon=cmons,trend=TRUE,std.lev=FALSE)
  
    plotStation(obs,what="t",add=TRUE,col="grey20",type="l",
  			    lwd=1,lty=3,l.anom=FALSE,mon=cmons,
  			    trend=FALSE,std.lev=FALSE)
  }
}

print(paste("Scenarios & ipcc version:",ipcc.ver))
i.gcm <- 0
for (gcm in gcms2) {
  i.gcm <- i.gcm + 1
  print(gcm)
  dot <- instring(".",gcm)
  if (length(dot)>=3) {
    gcm.nm <- substr(gcm,dot[1]-35,dot[1]-32)
  } else {
    dash <- instring("_",gcm)
    
    gcm.nm <- substr(gcm,dash[2]+1,dash[3]-1)
  }
  
  slsh <- instring("/",obs$location)
  subdir<-paste(strip(obs$location),ele,sep="_")
  fname <- paste(op.path,"/",subdir,"/ds_one_",ipcc.ver,"_",
                 strip(obs$location),"_",
                 ele,"_",gcm.nm,"_",scen,".",sep="")
                 
  if (!silent) print(fname)
  if (!file.exists(paste(fname,"txt",sep="")) &
        !file.exists(paste(fname,"Rdata",sep="")) | (force)) {
    
    GCM <- retrieve.nc(paste(dir,gcm,sep=""),
    				   x.rng=x.rng,y.rng=y.rng,v.nam=v.nam,
    		 		   silent=FALSE)
    class(GCM) <- c("field","monthly.field.object")
    GCM$attributes$time.unit<- "month"; GCM$dd[] <- 15
    attr(GCM$tim, "unit")<- "month";
    GCM$dat <- switch(as.character(ele),'101'=GCM$dat-273.15,
    '601'=GCM$dat*3600*24*30)
    
    ds.station <- objDS(ncep,GCM,obs,mon=cmons,plot=TRUE,
    					direc="dsgraphicsoutput/",
                        qualitycontrol=qc,silent=silent)
    x <- ds.station$station
    x$grade.pattern <- min(na.omit(
      c(ds.station$Jan$grade.pattern,ds.station$Feb$grade.pattern,
        ds.station$Mar$grade.pattern,ds.station$Apr$grade.pattern,
        ds.station$May$grade.pattern,ds.station$Jun$grade.pattern,
        ds.station$Jul$grade.pattern,ds.station$Aug$grade.pattern,
        ds.station$Sep$grade.pattern,ds.station$Oct$grade.pattern,
        ds.station$Nov$grade.pattern,ds.station$Dec$grade.pattern
        )))
    x$grade.trend <- min(na.omit(c(
      ds.station$Jan$grade.trend,ds.station$Feb$grade.trend,
      ds.station$Mar$grade.trend,ds.station$Apr$grade.trend,
      ds.station$May$grade.trend,ds.station$Jun$grade.trend,
      ds.station$Jul$grade.trend,ds.station$Aug$grade.trend,
      ds.station$Sep$grade.trend,ds.station$Oct$grade.trend,
      ds.station$Nov$grade.trend,ds.station$Dec$grade.trend
      )))
    
    x.ts <- plotStation(x,what="n",add=TRUE,col="steelblue",
                        type="l",lwd=2,lty=1,l.anom=FALSE,
                        mon=cmons,trend=TRUE,std.lev=FALSE)
                        
    if (!test) x$val <- x$val - x.ts$trend[1] +
     					obs.ts$trend[length(obs.ts$trend)]
    print(paste("Saving in",fname))
    
    if (!file.exists( paste(op.path,"/",subdir,sep="") )) {
      if (!silent) print(paste("Creating (3)",op.path,"/",
                               subdir,sep=""))
      dir.create( paste(op.path,"/",subdir,sep="") )
    } else if (!silent) print(paste(op.path,"/",subdir,
                                    " exists...",sep=""))
  save(file=paste(getwd(),"/",fname,"Rdata",sep="") ,x,ds.station)
  ds.scen <- data.frame(Year=x$yy,
                  Jan=round(x$val[,1],2),Feb=round(x$val[,2],2),
                  Mar=round(x$val[,3],2),Apr=round(x$val[,4],2),
                  May=round(x$val[,5],2),Jun=round(x$val[,6],2),
                  Jul=round(x$val[,7],2),Aug=round(x$val[,8],2),
                  Sep=round(x$val[,9],2),Oct=round(x$val[,10],2),
                  Nov=round(x$val[,11],2),Dec=round(x$val[,12],2
                    ))
                    
write.table(ds.scen,file=paste(getwd(),"/",fname,"txt",sep=""),
              row.names = FALSE,quote = FALSE, sep="\t ")
  } else {
    print(paste(fname,"exists, skipping ESD for this GCM."))
    load(paste(fname,"Rdata",sep=""))
  }
plotStation(x,what="t",add=TRUE,col="steelblue",type="l",lwd=2,
      lty=1,l.anom=FALSE,mon=cmons,trend=TRUE,std.lev=FALSE)
}
print("Add observations...")
plotStation(obs,what="t",add=TRUE,col="grey20",type="p",pch=19,
            l.anom=FALSE,mon=cmons,trend=TRUE,std.lev=FALSE)
print("Finished plotting")

dev.copy2eps(file=paste("ds_one_",
          ipcc.ver,obs$location,obs$ele, ".eps",sep=""))

if (test) invisible(
  
  x)
print("HERE")

